##############################################################################
#
# Copyright (c) 2006-2008 Kapil Thangavelu <kapil.foss@gmail.com>
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#
##############################################################################
"""
really simple visualizer.. transform models to graph viz.
"""

from io import StringIO

class ModelVisualizer( object ):

    def __init__( self, metadata ):
        self.metadata = metadata
        self.io = StringIO()
        
    def dot( self ):

        io = self.io
        
        print("digraph database {", file=io)
        tables = set()
        mapping_table = set()
        
        for t in self.metadata.table_iterator():
            options = []
            is_mapping = len(t.foreign_keys) == 2 and len( t.columns ) == 2
            
            if is_mapping:
                options.append( 'color=red')
            else:
                options.append( 'color=blue')
                
            is_vocabulary = len( t.foreign_keys ) == 0
            
            tables.add(
                ( t.name, is_vocabulary, is_mapping )
                )
                
            for f in t.foreign_keys:
                destination = f.column.table.name
                print('  %s -> %s [label="%s", %s];'%(
                    t.name, destination, f.parent.name, ', '.join(options)), file=io)

        for name, is_vocabulary, is_mapping in tables:
            if is_mapping:
                print(" %s [color=red];"%(name), file=io)
            if is_vocabulary:
                print(" %s [color=green];"%(name), file=io)
            else:
                print(" %s [shape=box];"%(name), file=io)
            
        print("}", file=io)
        
        return io.getvalue()

    def tofile( self, filename):
        fh = open( filename, 'w' )
        fh.write( self.dot() )
        fh.flush()
        fh.close()
        
